//+------------------------------------------------------------------+
//|                                           ezMM - Close Order.mq4 |
//|                              Copyright  2009, MethodTraders.com |
//|                                     http://www.methodtraders.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MethodTraders.com"
#property link      "http://www.methodtraders.com"
#include <WinUser32.mqh>

int MagicNumber;
string OT;
int Slippage;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
  //---- may be undefined (zero)
  if(ObjectFind("ezMM MagicNumber")!=-1)
  {
     double  drop_price=WindowPriceOnDropped();
     MagicNumber = StrToInteger(ObjectDescription("ezMM MagicNumber"));
     Slippage  = StrToInteger(ObjectDescription("ezMM Slip"));
     int ticket = NearestTrade(drop_price);
     if(ticket>0)
     {
        //int ret=MessageBox("Close "+OT+" Order #"+ticket+" ?", "Question", MB_YESNO|MB_ICONQUESTION);
        //if(ret==IDYES)
        //{    
            Comment( "ezMM - Close Order  | Closing Order#"+ticket+", please wait ..." );	
            Wait();
            subCloseOrder(ticket);
        //}
     }
  }
  Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+

void Wait() { while( IsTradeContextBusy() ) { Sleep(50); } }
int NearestTrade(double drop_price)
{
   int
      cnt, 
      total = 0;
   int ticket = 0;
   double Nearest = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
         {
            double Diff=MathAbs(drop_price-OrderOpenPrice());
            if(Diff == 0)Diff = 0.00000001;
            //Print("Diff= "+Diff);
            if(Nearest ==0||Diff<Nearest)
            {
               Nearest = Diff;
               ticket = OrderTicket();
         
               if(OrderType() == OP_BUY)OT = "BUY";
               if(OrderType() == OP_SELL)OT = "SELL";
            }
         }
   }
   return(ticket);
}
void subCloseOrder(int tk)
{
   int
         cnt, 
         total       = 0,
         ticket      = 0,
         err         = 0,
         c           = 0;

   total = OrdersTotal();
   int NumberOfTries = 10;
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol() == Symbol() &&
         OrderMagicNumber()==MagicNumber &&
         OrderTicket()==tk)
      {
         switch(OrderType())
         {
            case OP_BUY      :
               for(c=0;c<NumberOfTries;c++)
               {
                  RefreshRates();
                  ticket=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,CLR_NONE);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }   
               break;
               
            case OP_SELL     :
               for(c=0;c<NumberOfTries;c++)
               {
                  RefreshRates();
                  ticket=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,CLR_NONE);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }   
               break;
               
         }
      }
   }      
}

